var Model = {
    isMobile: null,
    finalImageSrc: null,
    backgroundSrc: "https://smartactivator.blob.core.windows.net/saassets/66fd46de-7db9-4af8-b452-20db243c9fc7/7b355a14-c846-4575-bff6-37b426c8db36/fgs-bkg-1-large.jpg",
    consumerSrc: null,
    overlaySrc: "https://smartactivator.blob.core.windows.net/saassets/66fd46de-7db9-4af8-b452-20db243c9fc7/7b355a14-c846-4575-bff6-37b426c8db36/overlay-1-medium.png",
    fakeConsumerSrc: "https://smartactivator.blob.core.windows.net/saassets/66fd46de-7db9-4af8-b452-20db243c9fc7/7b355a14-c846-4575-bff6-37b426c8db36/consumer-cropped.png",
    fakeConsumerSrc2: "https://smartactivator.blob.core.windows.net/saassets/66fd46de-7db9-4af8-b452-20db243c9fc7/7b355a14-c846-4575-bff6-37b426c8db36/tttest.jpg",
    loaderMessageArray: [
        "Please Wait",
        "It may take a minute",
        "Slow connection, hang on!",
        "Almost there"
    ]
}

$(document).ready(function () {
    $mz.onload();

    // var width = 1300;
    // var height = 1080;
    var width = 800;
    var height = 1080;
    var streaming = false;
    var video = null;
    var photoPicker = null;
    var canvas = null;
    var photo = null;

    var startButton = null;
    var uploadButton = null;
    var nextButton1 = null;
    var nextButton2 = null;
    var backButton = null;
    var finishButton = null;

    var slideActive = null;
    var slideNext = null;
    var slidePrev = null;

    var failedCounter = 0;

    var fgsTimeout = null;
    var outputFileInputPlaceholder = null;
    var introVideo = null;
    var processedSelfie = null;
    var reader = null;
    var imageID = null;

    var videoCounter = 0;

    var loaderInterval = null;
    var loaderInterval2 = null;
    var loaderCounter = 0;
    var globalSavedImage = null;

    var viewportWidth = window.innerWidth;
    var viewportOrientation = null;

    if (window.innerHeight > window.innerWidth) {
        viewportOrientation = "portrait";
    } else {
        viewportOrientation = "landscape";
    }

    // ============


    function init() {
        video = document.getElementById('video');
        canvas = document.getElementById('canvas');
        photo = document.getElementById('photo');
        photoPicker = document.getElementById("PhotoPicker");
        startButton = document.getElementById('startButton');
        uploadButton = document.getElementById('uploadButton');
        nextButton1 = document.getElementById('nextButton1');
        nextButton2 = document.getElementById('nextButton2');
        finishButton = document.getElementById('finishButton');
        backButton = $(".button_back");

        outputFileInputPlaceholder = $(".output__file-input-placeholder");
        introVideo = $(".intro__video");

        var widthVid = $(".output__video").width();
        var heightVid = widthVid * 0.75;

        $(".output__video").css("height", heightVid);

        console.log("VIEWPORT WIDTH = " + viewportWidth);
        console.log(viewportOrientation);

        loadForUserAgent();

        console.log(streaming);

        video.addEventListener('canplay', function (ev) {
            if (!streaming) {
                // height = video.videoHeight / (video.videoWidth / width);

                video.setAttribute('width', width);
                video.setAttribute('height', height);
                canvas.setAttribute('width', width);
                canvas.setAttribute('height', height);
                streaming = true;
            }
        }, false);

        photoPicker.addEventListener('change', function (e) {
            savePhotoFromInput(false);
        });

        uploadButton.addEventListener('click', function (e) {
            $("#PhotoPicker2").trigger("click");
        });

        $("#PhotoPicker2").on("change", function () {
            savePhotoFromInput(true);
        });

        startButton.addEventListener('click', function (e) {
            pushEffect("#startButton");

            if (Model.isMobile) {
                $("#PhotoPicker").trigger("click");
            } else if (streaming) {
                console.log(streaming)
                videoCounter++;
                $(".intro__image").addClass("intro__image_opacity-hidden");
                $(".intro__image").one("transitionend animationend", function () {
                    $(".intro__video").removeClass("intro__video_visibility-hidden");
                    $("#startButton").text("Capture");
                });
                if (videoCounter == 2) {
                    $(".intro__video").addClass("intro__video_visibility-hidden");
                    $(".loader").removeClass("loader_hidden");
                    $(".lds-hourglass").css("animation", "lds-hourglass 1.5s infinite");
                    savePhotoFromVideo();
                }
            } else if (!streaming) {
                $(".permissions").addClass("permissions_opacity-show");
                setTimeout(function () {
                    $(".permissions").removeClass("permissions_opacity-show");
                }, 4000);
            }

            e.preventDefault();
            e.stopPropagation();
        }, false);

        nextButton1.addEventListener('click', function (e) {
            pushEffect("#nextButton1");

            nextSlideTransition1();
        });

        nextButton2.addEventListener('click', function (e) {
            pushEffect("#nextButton2");

            $(".button").attr("disabled", "disabled");
            $(".flickity-button").attr("disabled", "disabled");

            $(".output__placeholder").css("visibility", "hidden");
            $(".output__overlay").css("visibility", "hidden");
            $(".loader").removeClass("loader_hidden");
            $(".lds-hourglass").css("animation", "lds-hourglass 1.5s infinite");

            savePhotoToCanvas();
        });

        backButton.on("click", function (e) {
            // $(".button").attr("disabled", "disabled");
            // $(".flickity-button").attr("disabled", "disabled");

            if ($(this).hasClass("second-back")) {
                backSlideTransition(false, true);
            } else {
                backSlideTransition(true, false);
            }

            e.preventDefault();
            e.stopPropagation();
        });

        finishButton.addEventListener('click', function (e) {
            window.location.reload();
        });

        function startLoaderInterval() {
            loaderInterval = setInterval(function () {
                if (loaderCounter < 4) {
                    var message = Model.loaderMessageArray[loaderCounter];
                    $(".loader__copy").text(message);
                    loaderCounter++;
                } else {
                    clearInterval(loaderInterval);
                    loaderCounter = 0;
                    $(".loader__copy").text("Loading...");
                }
            }, 6000)
        }

        function startLoaderInterval2() {
            loaderInterval2 = setInterval(function () {
                if (loaderCounter < 4) {
                    var message = Model.loaderMessageArray[loaderCounter];
                    $(".loader__copy2").text(message);
                    loaderCounter++;
                } else {
                    clearInterval(loaderInterval);
                    loaderCounter = 0;
                    $(".loader__copy2").text("Processing Photo");
                }
            }, 6000)
        }

        function loadForUserAgent() {
            if (navigator.userAgent.includes("Android") || navigator.userAgent.includes("iPhone")) {
                console.log("MOBILE DEVICE");
                Model.isMobile = true;
                runInputPhotoUpload();
                $("#mobile-instruction").css("display", "flex");
            } else if (navigator.mediaDevices && (viewportWidth > 1400)) {
                console.log("DESKTOP DEVICE");
                Model.isMobile = false;
                navigator.mediaDevices.getUserMedia({ video: true, audio: false })
                    .then(function (stream) {
                        video.srcObject = stream;
                        video.play();
                        $("#desktop-instruction").css("display", "flex");
                    })
                    .catch(function (err) {
                        console.log("An error occurred: " + err);
                        runInputPhotoUpload();
                        $("#mobile-instruction").css("display", "flex");
                    });

            } else {
                console.log("MOBILE DEVICE");
                Model.isMobile = true;
                runInputPhotoUpload();
                $("#mobile-instruction").css("display", "flex");
            }
        }

        function setSocialShareLinks() {
            var coverShareFB = 'https://moz-trk.com/i/share/fb/1B7BCF30-05FF-46CA-872C-E8BE3B031E97/k83yp2/{IMAGE_REDIRECT}';
            var coverShareTW = 'https://moz-trk.com/i/share/twitter/1B7BCF30-05FF-46CA-872C-E8BE3B031E97/k83yp2/{IMAGE_REDIRECT}';
            var coverShareIN = 'https://moz-trk.com/i/share/linkedin/1B7BCF30-05FF-46CA-872C-E8BE3B031E97/k83yp2/{IMAGE_REDIRECT}';

            coverShareIN = coverShareIN.replace("{IMAGE_REDIRECT}", imageID)
            coverShareFB = coverShareFB.replace("{IMAGE_REDIRECT}", imageID);
            coverShareTW = coverShareTW.replace("{IMAGE_REDIRECT}", imageID);

            $('.facebookLink').attr('href', coverShareFB);
            $('.twitterLink').attr('href', coverShareTW);
            $('.linkedinLink').attr('href', coverShareIN);

            nextSlideTransition2();

            $(".main").css("touch-action", "auto");
            $(".output").css("touch-action", "auto");

            $(".loader").addClass("loader_hidden");
            $(".output__placeholder").css("visibility", "visible");
            $(".output__overlay").css("visibility", "visible");
            $(".output__overlay").css("pointer-events", "none");
            $(".output__social-icons-wrapper").removeClass("output__social-icons-wrapper_hidden");

        }

        function hideInstruction() {
            $(".instruction").addClass("instruction_opacity-hidden")
            $(".instruction").one("transitionend", function () {
                $(".instruction").addClass("instruction_hidden");
                $("#canvas").trigger("click");
            });
        }

        function disableButtons() {
            $(".button").attr("disabled", "disabled");
        }

        function enableButtons() {
            $(".button").attr("disabled", false);
        }

        function pushEffect(id) {
            $(id).addClass('push');
            $(id).one('webkitAnimationEnd animationend', function () {
                $(id).removeClass('push');
            });
        }

        function runInputPhotoUpload() {
            introVideo.addClass("intro__video_hidden");
            outputFileInputPlaceholder.removeClass("output__file-input-placeholder_hidden");
        }

        function removeLoader() {
            $(".output__placeholder").removeClass("output__placeholder_hidden");
            $(".loader").addClass("loader_hidden");
        }

        function nextSlideTransition() {
            disableButtons();

            slideActive = $(".slide_active");
            slideNext = slideActive.next();

            anime({
                targets: '.slide_active .slide__section',
                translateX: 2600,
                easing: 'easeInOutCubic',
                delay: anime.stagger(150),
                complete: function () {
                    anime({
                        targets: '.slide_hidden .slide__section',
                        translateX: 2600,
                        duration: .25,
                        complete: function () {
                            $(".button").attr("disabled", false);
                            $(".flickity-button").attr("disabled", false);
                            slideActive.removeClass("slide_active");
                            slideActive.addClass("slide_hidden");
                            slideNext.removeClass("slide_hidden");
                            slideNext.addClass("slide_active");
                            slideActive = $(".slide_active");

                            enableButtons();
                            anime({
                                targets: '.slide_active .slide__section',
                                translateX: 0,
                                easing: 'easeInOutCubic',
                                delay: anime.stagger(150),
                                complete: function () {
                                    setTimeout(function () {
                                        hideInstruction();
                                    }, 4000);

                                    anime({
                                        targets: '.slide_hidden .slide__section',
                                        translateX: 0,
                                        easing: 'easeInOutCubic',
                                        complete: function () {
                                            $(".slide_hidden").css("display", "none");
                                        }
                                    })
                                }
                            })
                        }
                    })
                }
            })
        }

        function nextSlideTransition1() {
            disableButtons();

            slideActive = $(".slide_active");
            slideNext = slideActive.next();

            anime({
                targets: '.slide_active .slide__section_active',
                translateX: 2600,
                easing: 'easeInOutCubic',
                delay: anime.stagger(150),
                complete: function () {
                    $(".slide_active.slide__subtext").text("Step 3:")
                    $("#alwaysActive").removeClass("slide__section_active");
                    $("#alwaysActive").addClass("slide__section_hidden");
                    $(".slide__section_hidden").css("height", "auto");
                    $(".slide__section_hidden").css("position", "absolute");

                    anime({
                        targets: '.slide_active .slide__section_hidden',
                        translateX: 2600,
                        duration: .25,
                        complete: function () {
                            $(".slide__section_hidden").css("position", "relative");
                            $(".slide__section_active").css("height", "0");
                            $(".slide__section_hidden").css("visibility", "visible");
                            $(".slide__section_active").css("visibility", "hidden");
                            $(".output__overlay").css("visibility", "visible");
                            $(".output__overlay").css("pointer-events", "none");
                            enableButtons();

                            anime({
                                targets: '.slide_active .slide__section_hidden',
                                translateX: 0,
                                easing: 'easeInOutCubic',
                                delay: anime.stagger(150),
                                complete: function () {
                                    $(".slide_hidden").css("display", "none");
                                }
                            })
                        }
                    })
                }
            })
        }

        function nextSlideTransition2() {
            disableButtons();

            slideActive = $(".slide_active");
            slideNext = slideActive.next();

            console.log("TRANSTITON")

            anime({
                targets: '.slide_active .slide__section',
                translateX: 2600,
                easing: 'easeInOutCubic',
                delay: anime.stagger(150),
                complete: function () {
                    anime({
                        targets: '.slide_hidden .slide__section',
                        translateX: 2600,
                        duration: .25,
                        complete: function () {
                            $(".button").attr("disabled", false);
                            $(".flickity-button").attr("disabled", false);
                            slideActive.removeClass("slide_active");
                            slideActive.addClass("slide_hidden");
                            slideNext.removeClass("slide_hidden");
                            slideNext.addClass("slide_active");
                            $("#alwaysActive").removeClass("slide__section_active");
                            $("#alwaysActive").addClass("slide__section_hidden");

                            slideActive = $(".slide_active");

                            $(".slide_active").css("display", "flex");

                            enableButtons();
                            anime({
                                targets: '.slide_active .slide__section',
                                translateX: 0,
                                easing: 'easeInOutCubic',
                                delay: anime.stagger(150),
                                complete: function () {
                                    anime({
                                        targets: '.slide_hidden .slide__section',
                                        translateX: 0,
                                        easing: 'easeInOutCubic',
                                        complete: function () {
                                            $(".slide_hidden").css("display", "none");
                                        }
                                    })
                                }
                            })
                        }
                    })
                }
            })
        }

        function backSlideTransition(route1, route2) {
            disableButtons();
            if (route1) {
                $(".intro__image").removeClass("intro__image_opacity-hidden");
                slideActive = $(".slide_active");
                slidePrev = slideActive.prev();

                anime({
                    targets: '.slide_active .slide__section',
                    translateX: -2600,
                    easing: 'easeInOutCubic',
                    delay: anime.stagger(150),
                    complete: function () {
                        anime({
                            targets: '.slide_hidden .slide__section',
                            translateX: -2600,
                            duration: .25,
                            complete: function () {
                                // $(".button").attr("disabled", false);
                                // $(".flickity-button").attr("disabled", false);
                                slideActive.removeClass("slide_active");
                                slideActive.addClass("slide_hidden");
                                slidePrev.removeClass("slide_hidden");
                                slidePrev.addClass("slide_active");

                                slideActive = $(".slide_active");

                                $("#video").css("opacity", 0)

                                $(".slide_active").css("display", "flex");
                                enableButtons();

                                anime({
                                    targets: '.slide_active .slide__section',
                                    translateX: 0,
                                    easing: 'easeInOutCubic',
                                    delay: anime.stagger(150),
                                    complete: function () {
                                        $(".intro__video").addClass("intro__video_visibility-hidden");
                                        $("#startButton").text("Take Photo");
                                        videoCounter = 0;
                                        $("#video").css("opacity", 1);
                                        Model.consumerSrc = "";
                                        $(".output__consumer").attr("src", "");
                                        document.getElementById('canvas').getContext('2d').clearRect(0, 0, 800, 1080);
                                        document.getElementById('canvas2').getContext('2d').clearRect(0, 0, 800, 1080);
                                        document.getElementById('canvas3').getContext('2d').clearRect(0, 0, 800, 1080);
                                        $("#selfieBox").html("");

                                        anime({
                                            targets: '.slide_hidden .slide__section',
                                            translateX: 0,
                                            easing: 'easeInOutCubic',
                                            complete: function () {
                                                $(".slide_hidden").css("display", "none");
                                            }
                                        })
                                    }
                                })
                            }
                        })
                    }
                });
            }

            if (route2) {
                slideActive = $(".slide_active");
                slideNext = slideActive.next();

                anime({
                    targets: '.slide_active .slide__section_hidden',
                    translateX: -2600,
                    easing: 'easeInOutCubic',
                    delay: anime.stagger(150),
                    complete: function () {
                        $(".slide_active.slide__subtext").text("Step 2:")
                        $("#alwaysActive").removeClass("slide__section_hidden");
                        $("#alwaysActive").addClass("slide__section_active");

                        anime({
                            targets: '.slide_active .slide__section_active',
                            translateX: -2600,
                            duration: .25,
                            complete: function () {
                                $(".slide__section_active").css("height", "auto");
                                $(".slide__section_hidden").css("height", "0");
                                $(".slide__section_active").css("visibility", "visible");
                                $(".slide__section_hidden").css("visibility", "hidden");
                                $(".output__overlay").css("visibility", "hidden");
                                enableButtons();

                                anime({
                                    targets: '.slide_active .slide__section_active',
                                    translateX: 0,
                                    easing: 'easeInOutCubic',
                                    delay: anime.stagger(150),
                                    complete: function () {
                                        $(".slide_hidden").css("display", "none");
                                    }
                                })
                            }
                        })
                    }
                })
            }
        }

        function savePhotoFromInput(upload) {
            var selectedFile;
            var exifOrientation = null;
            var failedExifData = false;

            if (upload) {
                selectedFile = document.getElementById("PhotoPicker2").files[0];
            } else {
                selectedFile = document.getElementById("PhotoPicker").files[0];
            }

            reader = new FileReader();

            console.log(selectedFile);

            console.log(viewportOrientation);

            reader.addEventListener("load", function (e) {
                disableButtons();
                console.log("READER LOADED");
                var imageWidth = null;
                var imageHeight = null;
                var file;

                // convert image file to base64 string
                canvas.setAttribute('width', width);
                canvas.setAttribute('height', height);

                document.getElementById("canvas2").setAttribute('width', width);
                document.getElementById("canvas2").setAttribute('height', height);

                //Initiate the JavaScript Image object.
                var image = new Image();
                //Set the Base64 string return from FileReader as source.
                image.src = e.target.result;
                //Validate the File Height and Width.
                image.onload = function () {

                    // if (failedExifData) {
                    imageWidth = this.naturalWidth || this.width;
                    imageHeight = this.naturalHeight || this.height;

                    console.log(imageWidth + " - " + imageHeight);

                    if (imageWidth < imageHeight) {
                        exifOrientation = "6"
                    } else {
                        exifOrientation = "99"
                    }
                    // }

                    console.log(exifOrientation);


                    // console.log("HIDING INTRO AND SHOW LOADER");

                    $(".intro__image").addClass("intro__image_opacity-hidden");
                    $(".intro__image").one("transitionend animationend", function () {
                        $(".loader").removeClass("loader_hidden");
                        $(".lds-hourglass").css("animation", "lds-hourglass 1.5s infinite");
                    });


                    if (upload) {
                        file = document.getElementById("PhotoPicker2").files[0];
                    } else {
                        file = document.getElementById("PhotoPicker").files[0]
                    }

                    if (exifOrientation == "6") {
                        // if (!failedExifData) {
                        if (imageWidth > 2000) {
                            imageWidth = imageWidth / 3;
                            imageHeight = imageHeight / 3;
                        } else if (imageWidth > 1000) {
                            imageWidth = imageWidth / 2;
                            imageHeight = imageHeight / 2;
                        }
                        // }

                        console.log("IMAGE PORTRAIT");
                        console.log(imageWidth + " - " + imageHeight);
                        // $(".footer__text").text("PORTRAIT");
                        loadImage(
                            file,
                            function (img) {
                                $('#selfieBox').append(img);
                                $('#selfieBox').find('canvas').attr('id', 'sourceCanvas');
                                ctx = document.getElementById('canvas').getContext('2d');
                                console.log(ctx);
                                var konva = document.getElementById('sourceCanvas')
                                ctx.drawImage(konva, 0, 0)

                            },
                            { maxWidth: imageWidth, maxHeight: imageHeight, crop: true, orientation: true } // Options
                        );
                    } else {
                        // if (!failedExifData) {
                        if (imageWidth > 2000) {
                            imageWidth = imageWidth / 3;
                            imageHeight = imageHeight / 3;
                        } else if (imageWidth > 1000) {
                            imageWidth = imageWidth / 2;
                            imageHeight = imageHeight / 2;
                        }
                        // }

                        console.log("IMAGE LANDSCAPE");
                        console.log(imageWidth + " - " + imageHeight);
                        // $(".footer__text").text("LANDSCAPE");
                        loadImage(
                            file,
                            function (img) {
                                $('#selfieBox').append(img);
                                $('#selfieBox').find('canvas').attr('id', 'sourceCanvas');
                                ctx = document.getElementById('canvas').getContext('2d');
                                console.log(ctx);
                                var konva = document.getElementById('sourceCanvas')
                                ctx.drawImage(konva, 0, 0)

                            },
                            { maxWidth: imageWidth, maxHeight: imageHeight, crop: true, orientation: true } // Options
                        );
                    }

                    Model.isMobile = true;

                    setTimeout(function () {
                        var selfieCanvas = document.getElementById('canvas');
                        processedSelfie = selfieCanvas.toDataURL('image/png');
                        globalSavedImage = processedSelfie;
                        Model.consumerSrc = globalSavedImage;
                        processFgsPhoto(processedSelfie);
                    }, 1000);
                };

            }, false);

            if (selectedFile) {
                console.log("START PROCESSING");

                reader.readAsDataURL(selectedFile);
                EXIF.getData(selectedFile, function () {
                    if (EXIF.getTag(this, "Orientation")) {
                        console.log("EXIF TRUE");
                        exifOrientation = EXIF.getTag(this, "Orientation").toString();
                    } else {
                        console.log("EXIF NOT TRUE");
                        failedExifData = true;
                    }
                });
            }
        }

        function savePhotoFromVideo() {
            disableButtons();

            var selfieCanvas;
            var dataURL;
            var context = document.getElementById("canvas3").getContext('2d');

            if (width && height && !Model.isMobile) {
                console.log("GRAB VIDEO");

                canvas.setAttribute('width', width);
                canvas.setAttribute('height', height);

                document.getElementById("canvas3").setAttribute('width', width);
                document.getElementById("canvas3").setAttribute('height', height);

                document.getElementById("canvas2").setAttribute('width', width);
                document.getElementById("canvas2").setAttribute('height', height);

                context.drawImage(video, 0, 0);

                selfieCanvas = document.getElementById('canvas3');
                dataURL = selfieCanvas.toDataURL('image/png');
            }

            fgsTimeout = setTimeout(function () {
                if (dataURL) {
                    globalSavedImage = dataURL;
                    processFgsPhoto(dataURL);
                }
            }, 1000);
        }

        function processFgsPhoto(savedImage) {
            console.log("processing FGS");
            console.log(loaderInterval);
            startLoaderInterval();

            console.log("FAILED = " + failedCounter);

            $.ajax({
                url: "/image/removebg",
                type: "POST",
                data: { image: savedImage },
                dataType: "json",
                success: function (result) {
                    clearTimeout(fgsTimeout);
                    clearInterval(loaderInterval);
                    loaderCounter = 0;
                    console.log(result);

                    photo.src = 'data:image/png;base64,' + result.image + '';
                    console.log("REMOVEBG Return PHOTO W - " + photo.width)
                    console.log("REMOVEBG Return PHOTO H - " + photo.height)
                    Model.consumerSrc = photo.src;
                    $(".output__consumer").attr("src", Model.consumerSrc);

                    saveTest();

                    nextSlideTransition();

                    $("#startButton").text("Take Photo");
                    $(".loader__copy").text("Loading...");

                    removeLoader();

                    $("body").css("height", "auto");
                    $(".footer").css("margin", "5rem auto 1rem");

                    failedCounter = 0;
                },
                error: function (result) {
                    clearTimeout(fgsTimeout);
                    clearInterval(loaderInterval);
                    console.log(result.status);
                    console.log(result.statusText);
                    failedCounter++;

                    if (failedCounter == 1) {
                        // $(".loader__copy").text("Failed Once");
                        console.log("Failed Once");
                        setTimeout(function () {
                            processFgsPhoto(globalSavedImage);
                        }, 1000)
                    } else if (failedCounter == 2) {
                        // $(".loader__copy").text("Failed Twice");
                        console.log("Failed Twice");
                        setTimeout(function () {
                            processFgsPhoto(globalSavedImage);
                        }, 1000)
                    } else if (failedCounter == 3) {
                        clearInterval(loaderInterval)
                        loaderCounter = 0;

                        $(".loader__copy").text("Sorry, something went wrong!");
                        console.log("Failed Third");
                        setTimeout(function () {
                            failedCounter = 0;

                            if (window.location.origin.includes("localhost")) {
                                Model.consumerSrc = globalSavedImage;
                                // Model.consumerSrc = Model.fakeConsumerSrc2;
                                $(".output__consumer").attr("src", Model.consumerSrc);
                                saveTest();
                                nextSlideTransition();
                                removeLoader();
                                var stream = document.getElementById("video").srcObject;
                                if (stream) {
                                    var tracks = stream.getTracks();

                                    tracks.forEach(function (track) {
                                        track.stop();
                                    });
                                }
                            } else {
                                enableButtons();
                                $(".loader").addClass("loader_hidden");
                                $(".intro__image").removeClass("intro__image_opacity-hidden");
                                $(".loader__copy").text("Loading...");
                            }



                            // $(".output__consumer").attr("src", Model.consumerSrc);
                            // saveTest();
                            // nextSlideTransition();
                            // removeLoader();
                        }, 3000)
                    }

                    $("#startButton").text("Take Photo");
                }
            });
        }

        function saveTest() {
            runTheTest();
            var canvas = document.getElementById("canvas")
            var ctx = canvas.getContext("2d");
            var photo = new Image();
            var background = new Image();
            var overlay = new Image();

            photo.crossOrigin = "anonymous";
            background.crossOrigin = "anonymous";
            overlay.crossOrigin = "anonymous";

            background.onload = function () {
                // ctx.drawImage(background, 0, 0, width, height);
                photo.src = Model.consumerSrc;
            };

            photo.onload = function () {
                console.log("photo load");
                ctx.drawImage(photo, 0, 0, width, height);
                overlay.src = Model.overlaySrc;
            };

            overlay.onload = function () {
                console.log("overlay load")
            };

            background.src = Model.backgroundSrc;
        }

        function savePhotoToCanvas() {
            startLoaderInterval2();
            var testCan = document.getElementById("superKonva")
            Model.consumerSrc = testCan.toDataURL('image/png');

            // Model.consumerSrc = canvas.toDataURL('image/png');

            var ctx = document.getElementById("canvas2").getContext("2d");
            var photo = new Image();
            var background = new Image();
            var overlay = new Image();

            photo.crossOrigin = "anonymous";
            background.crossOrigin = "anonymous";
            overlay.crossOrigin = "anonymous";

            background.onload = function () {
                ctx.drawImage(background, 0, 0, 800, 1080);
                photo.src = Model.consumerSrc;
                console.log(photo.width + " " + photo.height);
            };

            photo.onload = function () {
                console.log("photo load");
                ctx.drawImage(photo, 0, 0, 800, 1080);
                overlay.src = Model.overlaySrc;
                console.log(overlay.width + " " + overlay.height);
            };

            overlay.onload = function () {
                console.log("overlay load")
                ctx.drawImage(overlay, 0, 0, 800, 1080);

                setTimeout(function () {
                    Model.finalImageSrc = document.getElementById("canvas2").toDataURL('image/png');
                    document.getElementById("photoFinal").src = Model.finalImageSrc;

                    // setSocialShareLinks(Model.finalImageSrc);

                    $(".downloadLink").attr("href", Model.finalImageSrc);

                    uploadPhotoToSA();
                }, 1000);
            };

            background.src = Model.backgroundSrc;
            // background.width = 1300;
            // background.height = 1080;
            console.log(background.width + " " + background.height);
        }

        function uploadPhotoToSA() {

            dataURL2 = Model.finalImageSrc.replace(/^data:image\/(png|jpg);base64,/, "");

            // dataURL2 = Model.finalImageSrc;

            var url = location.protocol + '//' + location.host + '/uploadPhoto';
            var data = {
                image: dataURL2,
                extension: 'png'
            };

            var xhr = new XMLHttpRequest();
            xhr.open('POST', url);
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.onreadystatechange = function () {
                if (xhr.readyState == 4 && xhr.status == 200) {
                    // showSpinner(false);
                    console.log("success");
                    console.log("PHOTO NAME = " + xhr.responseText);
                    getImageFromSA(xhr.responseText);

                } else if (xhr.readyState == 404) {
                    console.log("404");
                    // showSpinner(false);
                    // errorMessage();
                    // alert('error');
                }
            };

            xhr.send(JSON.stringify(data));
            //return;

        }

        function getImageFromSA(PhotoName) {
            console.log("start getImageFromSA()");
            $.ajax({
                type: "POST",
                url: "/getPhoto",
                action: "getPhoto",
                data: { "fileName": PhotoName },
                success: function (response) {
                    if (response != null && response != '') {

                        if (response.valid === true) {
                            console.log(response)
                            // urlGIF = response.url;
                            imageID = response.id;
                            // localStorage.setItem("imageID", response.id);
                            // updateShareLinks2();
                            setSocialShareLinks();
                            clearInterval(loaderInterval)
                            console.log("user photo = " + PhotoName);
                            // console.log(response);

                        } else {
                            console.log("Valid = False --> Re-Try...");
                            setTimeout(getImageFromSA, 1000);
                        }
                    } else {
                        console.log("No Response --> Re-Try...");
                        setTimeout(getImageFromSA, 1000);
                    }
                },
                error: function (response) {
                    console.log('error');
                }
            });
        }

        $(".flickity-button").on("click", function (e) {
            e.preventDefault();
            e.stopPropagation();

            var overlay = $(this).parents(".overlay-carousel");
            var background = $(this).parents(".background-carousel");

            if (overlay[0]) {
                Model.overlaySrc = overlay.find(".is-selected").children().first().children(".overlay-carousel__image").attr("src");
                $(".output__overlay").attr("src", Model.overlaySrc);
            }

            if (background[0]) {
                Model.backgroundSrc = background.find(".is-selected").children().first().children(".background-carousel__image").attr("src");
                $(".output__background").attr("src", Model.backgroundSrc);
            }
        });

        $(".background-carousel-wrapper > .flickity-viewport").on("transitionend pointerout", function () {
            var background = $(".background-cell.is-selected");
            var backgroundSource = background.children().first().children(".background-carousel__image").attr("src");

            if (Model.backgroundSrc === backgroundSource) {
                return;
            } else {
                Model.backgroundSrc = backgroundSource;
                $(".output__background").attr("src", Model.backgroundSrc);
            }
        });

        $(".overlay-carousel-wrapper > .flickity-viewport").on("transitionend pointerout", function () {
            var overlay = $(".overlay-cell.is-selected");
            var overlaySource = overlay.children().first().children(".overlay-carousel__image").attr("src");

            if (Model.overlaySrc === overlaySource) {
                return;
            } else {
                Model.overlaySrc = overlaySource;
                $(".output__overlay").attr("src", Model.overlaySrc);
            }
        });

        $(".background-carousel__image").on("click", function () {
            // $(".background-carousel__image").removeClass("background-carousel__image_selected");
            // $(this).addClass("background-carousel__image_selected");
            Model.backgroundSrc = $(this).attr("src");
            $(".output__background").attr("src", Model.backgroundSrc);
        });

        $(".overlay-carousel__image").on("click", function () {
            // $(".overlay-carousel__image").removeClass("overlay-carousel__image_selected");
            // $(this).addClass("overlay-carousel__image_selected");
            Model.overlaySrc = $(this).attr("src");
            $(".output__overlay").attr("src", Model.overlaySrc);
        });

        $(".output").on("click touchstart", function (e) {
            e.preventDefault;
            e.stopPropagation();

            $(".instruction").addClass("instruction_opacity-hidden")
            $(".instruction").one("transitionend", function () {
                $(".instruction").addClass("instruction_hidden");
                $("#canvas").trigger("click");
            });
        })

        $(window).on("orientationchange", function () {
            var width = $(".output__video").width();
            var height = width * 0.75;
            $(".output__video").css("height", height);

        });

        setTimeout(function () {
            $(".wrapper").addClass("wrapper_active");
        }, 1500)
    }

    init();
});